<?php

declare (strict_types=1);
namespace WptoprSEO_Vendor\GuzzleHttp\Psr7;

use WptoprSEO_Vendor\Psr\Http\Message\RequestFactoryInterface;
use WptoprSEO_Vendor\Psr\Http\Message\RequestInterface;
use WptoprSEO_Vendor\Psr\Http\Message\ResponseFactoryInterface;
use WptoprSEO_Vendor\Psr\Http\Message\ResponseInterface;
use WptoprSEO_Vendor\Psr\Http\Message\ServerRequestFactoryInterface;
use WptoprSEO_Vendor\Psr\Http\Message\ServerRequestInterface;
use WptoprSEO_Vendor\Psr\Http\Message\StreamFactoryInterface;
use WptoprSEO_Vendor\Psr\Http\Message\StreamInterface;
use WptoprSEO_Vendor\Psr\Http\Message\UploadedFileFactoryInterface;
use WptoprSEO_Vendor\Psr\Http\Message\UploadedFileInterface;
use WptoprSEO_Vendor\Psr\Http\Message\UriFactoryInterface;
use WptoprSEO_Vendor\Psr\Http\Message\UriInterface;
/**
 * Implements all of the PSR-17 interfaces.
 *
 * Note: in consuming code it is recommended to require the implemented interfaces
 * and inject the instance of this class multiple times.
 */
final class HttpFactory implements \WptoprSEO_Vendor\Psr\Http\Message\RequestFactoryInterface, \WptoprSEO_Vendor\Psr\Http\Message\ResponseFactoryInterface, \WptoprSEO_Vendor\Psr\Http\Message\ServerRequestFactoryInterface, \WptoprSEO_Vendor\Psr\Http\Message\StreamFactoryInterface, \WptoprSEO_Vendor\Psr\Http\Message\UploadedFileFactoryInterface, \WptoprSEO_Vendor\Psr\Http\Message\UriFactoryInterface
{
    public function createUploadedFile(\WptoprSEO_Vendor\Psr\Http\Message\StreamInterface $stream, ?int $size = null, int $error = \UPLOAD_ERR_OK, ?string $clientFilename = null, ?string $clientMediaType = null) : \WptoprSEO_Vendor\Psr\Http\Message\UploadedFileInterface
    {
        if ($size === null) {
            $size = $stream->getSize();
        }
        return new \WptoprSEO_Vendor\GuzzleHttp\Psr7\UploadedFile($stream, $size, $error, $clientFilename, $clientMediaType);
    }
    public function createStream(string $content = '') : \WptoprSEO_Vendor\Psr\Http\Message\StreamInterface
    {
        return \WptoprSEO_Vendor\GuzzleHttp\Psr7\Utils::streamFor($content);
    }
    public function createStreamFromFile(string $file, string $mode = 'r') : \WptoprSEO_Vendor\Psr\Http\Message\StreamInterface
    {
        try {
            $resource = \WptoprSEO_Vendor\GuzzleHttp\Psr7\Utils::tryFopen($file, $mode);
        } catch (\RuntimeException $e) {
            if ('' === $mode || \false === \in_array($mode[0], ['r', 'w', 'a', 'x', 'c'], \true)) {
                throw new \InvalidArgumentException(\sprintf('Invalid file opening mode "%s"', $mode), 0, $e);
            }
            throw $e;
        }
        return \WptoprSEO_Vendor\GuzzleHttp\Psr7\Utils::streamFor($resource);
    }
    public function createStreamFromResource($resource) : \WptoprSEO_Vendor\Psr\Http\Message\StreamInterface
    {
        return \WptoprSEO_Vendor\GuzzleHttp\Psr7\Utils::streamFor($resource);
    }
    public function createServerRequest(string $method, $uri, array $serverParams = []) : \WptoprSEO_Vendor\Psr\Http\Message\ServerRequestInterface
    {
        if (empty($method)) {
            if (!empty($serverParams['REQUEST_METHOD'])) {
                $method = $serverParams['REQUEST_METHOD'];
            } else {
                throw new \InvalidArgumentException('Cannot determine HTTP method');
            }
        }
        return new \WptoprSEO_Vendor\GuzzleHttp\Psr7\ServerRequest($method, $uri, [], null, '1.1', $serverParams);
    }
    public function createResponse(int $code = 200, string $reasonPhrase = '') : \WptoprSEO_Vendor\Psr\Http\Message\ResponseInterface
    {
        return new \WptoprSEO_Vendor\GuzzleHttp\Psr7\Response($code, [], null, '1.1', $reasonPhrase);
    }
    public function createRequest(string $method, $uri) : \WptoprSEO_Vendor\Psr\Http\Message\RequestInterface
    {
        return new \WptoprSEO_Vendor\GuzzleHttp\Psr7\Request($method, $uri);
    }
    public function createUri(string $uri = '') : \WptoprSEO_Vendor\Psr\Http\Message\UriInterface
    {
        return new \WptoprSEO_Vendor\GuzzleHttp\Psr7\Uri($uri);
    }
}
